Unit zp33e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure zp33e(NP :Integer; var A :Array of Extended; M :Integer;
                var B :Array of Extended; var K :Integer);

implementation

procedure zp33e(NP :Integer; var A :Array of Extended; M :Integer;
                var B :Array of Extended; var K :Integer);
var
I,I1,I2,K1,KJ,N,NN,J :Integer;
X :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
I := 0;
N := NP;
_1:
I := I+1;
if ( A[I-1] <> 0.e0 ) 
 then goto _2;
if ( I <= N ) 
 then goto _1;
B[0] := 0.e0;
if ( M > 1 ) 
 then goto _3;
goto _8;
_2:
K := I-1;
K1 := K+1;
NN := N-K+1;
B[0] := 1.e0/A[K+0];
if ( M <= 1 ) 
 then goto _8;
if ( NN > 1 ) 
 then goto _5;
_3:
for J:=2 to M do
 begin
_4:
  B[J-1] := 0.e0;
 end;
goto _8;
_5:
for I:=2 to M do
 begin
  X := 0.e0;
  KJ := K1+I-2;
  if ( KJ > NP ) 
   then KJ := NP;
  for I1:=K1 to KJ do
   begin
    I2 := I-I1;
_6:
    X := X+(A[I1+0])*(B[I2-1]);
   end;
_7:
  B[I-1] := -X*B[0];
 end;
_8:
end;

end.
